
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class User_gamificationDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_gamification = await db.user_gamification.create(
            {
                id: data.id || undefined,
        
        points_total: data.points_total
        ||
        null
            ,
            
        streak_days: data.streak_days
        ||
        null
            ,
            
        last_activity_at: data.last_activity_at
        ||
        null
            ,
            
        daily_activity_json: data.daily_activity_json
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await user_gamification.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return user_gamification;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const user_gamificationData = data.map((item, index) => ({
                id: item.id || undefined,
                
                points_total: item.points_total
            ||
            null
            ,
            
                streak_days: item.streak_days
            ||
            null
            ,
            
                last_activity_at: item.last_activity_at
            ||
            null
            ,
            
                daily_activity_json: item.daily_activity_json
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const user_gamification = await db.user_gamification.bulkCreate(user_gamificationData, { transaction });

        // For each item created, replace relation files
        

        return user_gamification;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const user_gamification = await db.user_gamification.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.points_total !== undefined) updatePayload.points_total = data.points_total;
        
        
        if (data.streak_days !== undefined) updatePayload.streak_days = data.streak_days;
        
        
        if (data.last_activity_at !== undefined) updatePayload.last_activity_at = data.last_activity_at;
        
        
        if (data.daily_activity_json !== undefined) updatePayload.daily_activity_json = data.daily_activity_json;
        
        
        updatePayload.updatedById = currentUser.id;

        await user_gamification.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await user_gamification.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return user_gamification;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_gamification = await db.user_gamification.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of user_gamification) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of user_gamification) {
                await record.destroy({transaction});
            }
        });


        return user_gamification;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const user_gamification = await db.user_gamification.findByPk(id, options);

        await user_gamification.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await user_gamification.destroy({
            transaction
        });

        return user_gamification;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const user_gamification = await db.user_gamification.findOne(
            { where },
            { transaction },
        );

        if (!user_gamification) {
            return user_gamification;
        }

        const output = user_gamification.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await user_gamification.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.daily_activity_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'user_gamification',
                        'daily_activity_json',
                        filter.daily_activity_json,
                    ),
                };
            }
            

            
            

            
            if (filter.points_totalRange) {
                const [start, end] = filter.points_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    points_total: {
                    ...where.points_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    points_total: {
                    ...where.points_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.streak_daysRange) {
                const [start, end] = filter.streak_daysRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    streak_days: {
                    ...where.streak_days,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    streak_days: {
                    ...where.streak_days,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_activity_atRange) {
                const [start, end] = filter.last_activity_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_activity_at: {
                    ...where.last_activity_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_activity_at: {
                    ...where.last_activity_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.user_gamification.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'user_gamification',
                        'daily_activity_json',
                        query,
                    ),
                ],
            };
        }

        const records = await db.user_gamification.findAll({
            attributes: [ 'id', 'daily_activity_json' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['daily_activity_json', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.daily_activity_json,
        }));
    }

    
};

